if($Pref::Server::Angels::NoFriendlyFreezing $= "")
	$Pref::Server::Angels::NoFriendlyFreezing = 0;

AddDamageType("WeepingAngel", '<bitmap:Add-Ons/Server_WeepingAngels/CI_WeepingAngel> %1', '%2 <bitmap:Add-Ons/Server_WeepingAngels/CI_WeepingAngel> %1', 1, 1);

package WeepingAngels
{
	function Player::damage(%pl, %proj, %pos, %damage, %type)
	{
		if(%pl.WeepingAngel) return;
		Parent::damage(%pl, %proj, %pos, %damage, %type);
	}
};
activatePackage("WeepingAngels");

function WA_CheckLOS(%pl, %bot)
{
	%pi = 3.14159265;
	%eye = %pl.getEyePoint();
	%dir = %pl.getEyeVector();
	%ang = mAtan(getWord(%dir, 0), getWord(%dir, 1)) + (%pi / 2);
	%pos0 = %bot.getHackPosition(); %pos1 = %bot.getPosition();
	%pos2 = vectorAdd(%pos0, vectorSub(%pos0, %pos1));
	%add = mSin(%ang) SPC mCos(%ang);
	%pos3 = vectorAdd(%pos0, vectorScale(%add, 0.75 * getWord(%bot.getScale(), 2)));
	%pos4 = vectorAdd(%pos0, vectorScale(%add, -0.75 * getWord(%bot.getScale(), 2)));
	for(%i=0;%i<5;%i++)
		if(vectorDist(%dir, vectorNormalize(vectorSub(%pos[%i], %pl.getHackPosition()))) <= 1.000)
		{ %flag = 1; %check[-1+%check++] = %pos[%i]; }
	if(!%flag) return 0;
	%masks = $Typemasks::PlayerObjectType | $Typemasks::VehicleObjectType | $Typemasks::fxBrickAlwaysObjectType;
	for(%i=0;%i<%check;%i++)
	{
		for(%j=0;%j<3;%j++)
		{
			%hit = containerRaycast(%eye, %check[%i], %masks, %pl, %bot, %hit0, %hit1, %hit2);
			if(!isObject(%hit)) return 1;
			else if(%hit.getClassName() $= "fxDtsBrick" && (%hit.isFakeDead() || !%hit.isRendering() || getWord(getColorIDTable(%hit.getColorID()), 3) != 1))
				%hit[%j] = %hit;
			else
				%j = 3;
		}
	}
	return 0;
}

function servercmdSpawnAngels(%cl)
{
	%groups = MainBrickgroup.getCount();
	for(%i=0;%i<%groups;%i++)
	{
		%group = MainBrickgroup.getObject(%i);
		%count = %group.getCount();
		for(%j=0;%j<%count;%j++)
		{
			%brick = %group.getObject(%j);
			if(%brick.getDatablock().getName() $= "brickSpawnPointData" && %brick.getBrickName() $= "AngelSpawn")
			{
				SpawnWeepingAngel(vectorAdd(%brick.getPosition(), "0 0 -1.25") SPC getWords(%brick.getTransform(), 3, 6));
			}
		}
	}
}

function AIPlayer::WeepingAngelLoop(%bot, %freeze, %targ)
{
	cancel(%bot.AILoop);
	if(%bot.getState() $= "DEAD")
	{ if(isObject(%cl = %bot.client)) %cl.delete(); return; }
	%bot.WaitingAngel = 0;
	%pos = %bot.getHackPosition();
	initContainerRadiusSearch(%pos, 240, $Typemasks::PlayerObjectType);
	while(isObject(%obj = containerSearchNext()))
	{
		if(%bot.getID() == %obj.getID()) continue;
		if(%obj.getState() $= "DEAD") continue;
		if(%obj.WeepingAngel && !%obj.WaitingAngel)
			%seesOthers += WA_CheckLOS(%bot, %obj);
		if(%obj.WeepingAngel && (%obj.WaitingAngel || %obj.getDatablock().getName() $= "WeepingAngelUpArmor" || $Pref::Server::Angels::NoFriendlyFreezing))
			continue;
		if(!%obj.WeepingAngel) %item[-1+%items++] = %obj;
		%seen += WA_CheckLOS(%obj, %bot);
	}
	if(vectorLen($EnvGuiServer::DirectLightColor) > 0.1)
		%lit = 1;
	if(%seen && !%lit)
	{
		initContainerRadiusSearch(%pos, 40, $TypeMasks::StaticRenderedObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getClassName() !$= "fxLight") continue;
			if((%data = %obj.getDatablock()).radius * 2 >= vectorDist(%pos, %obj.getPosition()))
				%lit = 1;
		}
	}
	if(!%seen || !%lit)
	{
		%freeze = 0;
		initContainerRadiusSearch(%pos, 3, $TypeMasks::StaticRenderedObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getClassName() !$= "fxLight") continue;
			%obj.delete();
		}
		for(%i=0;%i<%items;%i++)
		{
			if((%dist = vectorDist(%pos, %item[%i].getHackPosition())) < %closest || %closest $= "")
			{
				%closest = %dist;
				%targ = %item[%i];
			}
		}
		if(isObject(%targ) && %closest $= "")
		{ %closest = vectorDist(%pos, %targ.getHackPosition()); }
		if(%closest !$= "")
		{
			if(%closest <= 6)
				%bot.changeDatablock(WeepingAngelDownArmor);
			else if(%closest <= 9 && %seesOthers <= 1)
				%bot.changeDatablock(WeepingAngelDownArmor);
			else if(%seesOthers)
				%bot.changeDatablock(WeepingAngelUpArmor);
			else if(%closest <= 12)
				%bot.changeDatablock(WeepingAngelDownArmor);
			else if(%closest <= 32)
				%bot.changeDatablock(WeepingAngelIdleArmor);
			else
				%bot.changeDatablock(WeepingAngelUpArmor);
		}
		if(isObject(%targ) && %targ.getState() !$= "DEAD")
		{
			%mask = $Typemasks::fxBrickObjectType | $Typemasks::PlayerObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType;
			if(isObject(%hit = containerRaycast(%eye = %bot.getEyePoint(), vectorAdd(%eye, vectorScale(%bot.getEyeVector(), 3)), %mask, %bot)))
			{
				if(%hit.getType() & $Typemasks::PlayerObjectType && !%hit.WeepingAngel && %bot.getDatablock().getName() $= "WeepingAngelDownArmor")
					%hit.damage(0, %hit.getHackPosition(), 10000, $DamageType::WeepingAngel);
			}
			if(isObject(%targ) && %targ.getState() !$= "DEAD")
			{
				%bot.setAimObject(%targ);
				if(vectorDot(vectorNormalize(vectorSub(%targ.getPosition(), %bot.getPosition())), %bot.getEyeVector()) >= 0.85)
					%bot.setMoveY(50);
				else	%bot.setMoveY(0);
				%bot.setMoveX(0);
			}
		}
		else
		{
			%bot.setAimObject(0);
			%bot.setMoveY(0);
			%bot.setMoveX(0);
		}
	}
	else if(!%freeze)
	{
		%bot.setVelocity("0 0 0");
		%bot.setAimObject(0);
		%bot.setMoveY(0);
		%bot.setMoveX(0);
		%freeze = 1;
	}
	else
	{
		%bot.setAimObject(0);
		%bot.setMoveY(0);
		%bot.setMoveX(0);
	}
	%bot.AILoop = %bot.schedule(48, "WeepingAngelLoop", %freeze, %targ);
}

function SpawnWeepingAngel(%trans)
{
	%bot = new AIPlayer() { datablock = WeepingAngelUpArmor; };
	%cl = new AIConnection() { player = %bot; chestColor = "0.5 0.5 0.5 1.0"; }; %bot.client = %cl;
	if(!isObject(%bot) || !isObject(%cl))
	{ if(isObject(%bot)) %bot.delete(); if(isObject(%cl)) %cl.delete(); return 0; }
	%bot.setTransform(%trans);
	%bot.WeepingAngel = 1;
	%bot.setNodeColor("ALL", "0.5 0.5 0.5 1.0");
	%bot.schedule(1000, "WeepingAngelLoop", 1, 0);
}

datablock TSShapeConstructor(WeepingAngelUpDts)
{ baseShape = "./Weeping Angel Up.dts"; };

datablock TSShapeConstructor(WeepingAngelIdleDts)
{ baseShape = "./Weeping Angel Idle.dts"; };

datablock TSShapeConstructor(WeepingAngelDownDts)
{ baseShape = "./Weeping Angel Down.dts"; };

datablock PlayerData(WeepingAngelUpArmor : PlayerStandardArmor)
{
	shapeFile = "./Weeping Angel Up.dts";
	uiName = "Weeping Angel - Hands Up";
	maxBackwardSpeed = 16;
	maxForwardSpeed = 28;
	maxSideSpeed = 24;
	runForce = 17280;
};

datablock PlayerData(WeepingAngelIdleArmor : WeepingAngelUpArmor)
{ shapeFile = "./Weeping Angel Idle.dts"; uiName = "Weeping Angel - Hands Down"; };

datablock PlayerData(WeepingAngelDownArmor : WeepingAngelUpArmor)
{ shapeFile = "./Weeping Angel Down.dts"; uiName = "Weeping Angel - Demonic"; };